# Release Notes

{% hint style="success" %}
These release notes are specific to **CARTO for Developers** and should be read as a complement to:

* The [official CARTO what's new](/whats-new.md)
* The [official deck.gl changelog](https://deck.gl/docs/whats-new)
  {% endhint %}

## March 25th, 2026

### <mark style="color:blue;">**`@carto/agentic-deckgl`**</mark> **`0.1.0`**

[View in Github](https://github.com/CartoDB/carto-agentic-deckgl)

* **New library: AI-powered map interaction.** `@carto/agentic-deckgl` is a framework-agnostic TypeScript library that enables natural language control of [CARTO + deck.gl](https://github.com/CartoDB/gitbook-documentation/blob/master/carto-for-developers/key-concepts/carto-for-deck.gl) maps through AI-powered tool calling. [Learn more](/carto-for-developers/key-concepts/ai-powered-map-interaction.md).
* 3 consolidated tools for complete map control: `set-deck-state`, `set-marker`, and `set-mask-layer`.
* Built-in system prompt generation with map state context and optional user context.
* SDK converters for [OpenAI Agents SDK](https://github.com/openai/openai-agents-js), [Vercel AI SDK](https://sdk.vercel.ai/), and [Google ADK](https://google.github.io/adk-docs/).
* Reference frontend implementations for React, Vue, Angular, and Vanilla JS.

## October 7th, 2025

### <mark style="color:purple;">**`@carto/api-client`**</mark> **`0.5.21`**

[View in Github](https://github.com/CartoDB/carto-api-client/)

* [Data sources](/carto-for-developers/reference/data-sources.md) are now part of @carto/api-client

### <mark style="color:red;">**`@deck.gl`**</mark> **`9.2`**

[What's new](https://deck.gl/docs/whats-new#deckgl-v92)

* New widgets have been added, for easy integration of FPS, screenshot, and similar UI controls.
* deck.gl now offers [WebGPU early preview](https://deck.gl/docs/whats-new#webgpu-early-preview).
* **Changes in the @deck.gl/CARTO module:**
  * [ClusterTileLayer](https://deck.gl/docs/api-reference/carto/cluster-tile-layer) and [HeatmapTileLayer](https://deck.gl/docs/api-reference/carto/heatmap-tile-layer) now support H3-based data sources.
  * [VectorTileLayer](https://deck.gl/docs/api-reference/carto/vector-tile-layer) supports automatic labels with controlled placement for line & polygon data, via new [`autoLabels`](https://deck.gl/docs/api-reference/carto/vector-tile-layer#autolabels) prop.

## June 16th, 2025 <a href="#v88---june-30-2022" id="v88---june-30-2022"></a>

### <mark style="color:purple;">**`@carto/api-client`**</mark> **`0.5.8`**

[View in Github](https://github.com/CartoDB/carto-api-client/)

* **Custom aggregation for getCategories and getTimeSeries models:** You can now specify custom SQL aggregation (`operationExp`) in your [categories](/carto-for-developers/reference/carto-widgets-reference/models/getcategories.md) and [time series](/carto-for-developers/reference/carto-widgets-reference/models/gettimeseries.md) models.
* **Automatic aggregation as "others" in getCategories:** Specifiy `othersThreshold` in your [getCategories](/carto-for-developers/reference/carto-widgets-reference/models/getcategories.md) model and CARTO will automatically aggregate the values for any additional categories as `_carto_others`

## May 20th, 2025 <a href="#v88---june-30-2022" id="v88---june-30-2022"></a>

### <mark style="color:purple;">**`@carto/api-client`**</mark> **`0.5.5`**

[View in Github](https://github.com/CartoDB/carto-api-client/)

* **Extended support for fetchMap:** Developers can use [fetchMap](/carto-for-developers/reference/fetchmap.md) directly from `carto/api-client` to integrate layers and interactions from Builder maps in their applications.

## March 27th, 2025 <a href="#v88---june-30-2022" id="v88---june-30-2022"></a>

### <mark style="color:purple;">**`@carto/api-client`**</mark> **`0.5.0`**

[View in Github](https://github.com/CartoDB/carto-api-client/)

* **Widgets for Tileset and Raster sources:** Developers using CARTO can now create custom, scalable charts and widgets on top of tilesets and raster sources, powered by GPU, client-side calculations.

## Jan 12th, 2025

### <mark style="color:purple;">**`@carto/api-client`**</mark> **`0.4.4`**

[View in Github](https://github.com/CartoDB/carto-api-client/)

* [Data sources](/carto-for-developers/reference/data-sources.md) are now part of @carto/api-client

### <mark style="color:red;">**`@deck.gl`**</mark> **`9.1`**

[What's new](https://deck.gl/docs/whats-new#deckgl-v91) | [Upgrade guide](https://deck.gl/docs/upgrade-guide#upgrading-to-v91)

* deck.gl continues its roadmap towards [WebGPU-readiness](https://deck.gl/docs/whats-new#webgpu-readiness), among other features you can discover in the [deck.gl what's new](https://deck.gl/docs/whats-new#deckgl-v91).
* **Changes in the @deck.gl/CARTO module:**
  * `@carto/api-client` is now a dependency, starting with `0.4.4`
  * Starting in deck.gl 9.1, you should import your [data sources](/carto-for-developers/reference/data-sources.md) directly from `@carto/api-client`

## Jan 7th, 2025

### <mark style="color:purple;">**`@carto/api-client`**</mark> **`0.4.0`**

[View in Github](https://github.com/CartoDB/carto-api-client/)

* **Widgets for Spatial-index sources:** Developers using CARTO can now create custom, scalable widgets on top of their spatial index data sources, in the Javascript framework of their choice. [Learn more in our what's new announcement](/whats-new/q1-2025.md#develop-completely-custom-widgets-powered-by-h3-and-quadbin-spatial-index-based-sources).

## October 9th, 2024

### <mark style="color:purple;">**`@carto/api-client`**</mark> **`0.3.1`**

[View in Github](https://github.com/CartoDB/carto-api-client/)

* **New framework-agnostic widgets in CARTO:** Build completely [custom charts and widgets](/carto-for-developers/key-concepts/charts-and-widgets.md) on top of your CARTO vector-based sources using the framework of your choice, fully powered by your data warehouse. Accelerate your development times, even for large scale data.[ Learn more in the CARTO what's new](/whats-new/q4-2024.md#new-framework-agnostic-widgets-in-carto-for-developers).
* **New filter constructors for CARTO widgets and sources:** Seamlessly add interactivity and filter the charts and layers in your app with our new [Filter constructors](/carto-for-developers/reference/filters.md), for both column-based and spatial-based filtering.

## March 27th, 2024

### <mark style="color:red;">**`@deck.gl`**</mark> **`9.0`**

[What's new](https://deck.gl/docs/whats-new#deckgl-v89) | [Upgrade guide](https://deck.gl/docs/upgrade-guide#upgrading-from-deckgl-v88-to-v89)

* **New CARTO module architecture:**
  * The `CartoLayer` has been replaced by **Sources** and **Layers**, that provide more flexibility and readability.
  * The `setDefaultCredentials` function has been removed. Authentication must be passed to the **Source**, providing more flexibility for a single codebase.
  * The `fetchLayerData` function has been replaced by the new **`query`** function, which provides a simpler interface to request data to the CARTO SQL API. This data can then be used in other `deck.gl` layers.

## March 9th, 2023

<mark style="color:red;">**`@deck.gl`**</mark> **8.9**\
[What's new](https://deck.gl/docs/whats-new#deckgl-v89) | [Upgrade guide](https://deck.gl/docs/upgrade-guide#upgrading-from-deckgl-v88-to-v89)

## June 30th, 2022

<mark style="color:red;">**`@deck.gl`**</mark> **8.8**\
[What's new](https://deck.gl/docs/whats-new#deckgl-v89) | [Upgrade guide](https://deck.gl/docs/upgrade-guide#upgrading-from-deckgl-v88-to-v89)

* The `CartoLayer` now works only with dynamic tiles. The `format` property has been removed. If you want to keep using GeoJSON instead of tiles, you need to use the `fetchLayerData` function.
* Dynamic tiles support for SQL queries.
* Support for dynamic and static tilesets with data aggregated using H3 and Quadbin discrete global grids. New `aggregationExp` and `aggregationResLevel` props in `CartoLayer`.

## February 25th, 2022

<mark style="color:red;">**`@deck.gl`**</mark> **8.7**

* New `fetchMap` function for loading a Builder map.
* New `MaskExtension` to apply a spatial mask to layers.
* Support for dynamic tiling with `MAP_TYPES.TABLE` data sources.
* New `QuadkeyLayer` supporting visualization of data using the Quadkey spatial indexing scheme.
* Changes in configuration defaults: `apiBaseUrl` now defaults to `https://gcp-us-east1.api.carto.com` and `apiVersion` to `API_VERSIONS.V3`. If you have code using a CARTO 2 dataset and you have not specified the `apiVersion` property, your code needs to be updated in order to work with the new version.
* New `format` and `formatTiles` props in `CartoLayer`.

## October 12th, 2021

<mark style="color:red;">**`@deck.gl`**</mark> **8.6**

* Default to binary mode in `MVTLayer`.
* Include API error at the exception message.
* New `geoColumn` and `columns` props in `CartoLayer`.
* Fix `MVTLayer` autoHighlight with binary data.
* Check for correct layerName when highlighting in `MVTLayer`.

In addition to these changes to the CARTO for `deck.gl` module and the `MVTLayer`, we have also implemented support for the new Google Maps vector rendering features in the Google Maps module.

## July 26th, 2021

<mark style="color:red;">**`@deck.gl`**</mark> **8.5**

* CARTO 3 integration.
* New `CartoLayer` supporting all the Maps API versions (`CartoSQLLayer` and `CartoBQTiler` layers will be deprecated and we recommend migrating existing code).
* Support triangulation of polygons for `MVTLoader` in loaders.gl.
* Support `pointType` prop to allow changing point rendering in `GeoJsonLayer`.

## February 1st, 2021

<mark style="color:red;">**`@deck.gl`**</mark> **8.4**

* Basemap module for `@deck.gl/carto`.
* Style helpers and CARTO colors.
* Support for CARTO Maps API v2.
* Add `onDataLoad` and `onDataError` callbacks to CARTO layers.
* TileJSON support to the `MVTLayer`.
* `MVTLayer` `getRenderedFeatures`.
* `MVTLayer` coordinates transformation to WGS84.
* `MVTLayer` binary data support.

## October 12th, 2020

<mark style="color:red;">**`@deck.gl`**</mark> **8.3**

* Add `@deck.gl/carto` module (`CartoSqlLayer` and `CartoBQTilerLayer`).
* `MVTLayer`: support globe view.

## June 28th, 2020

<mark style="color:red;">**`@deck.gl`**</mark> **8.2**

* Fix `MVTLayer` projection precision.
* `FillStyleExtension` supports `MVTLayer`.

## March 17th, 2020

<mark style="color:red;">**`@deck.gl`**</mark> **8.1**

* New `MVTLayer` for working with vector tiles.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.carto.com/carto-for-developers/release-notes.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
